#! /bin/sh

upgrade_result()
{
   if [ x$iot_upgrade = x"byiot" ]
   then
       if [ $1 -eq 1 ]
       then
          echo upgrade ok
          echo "d 83" > /tmp/mqttdownfifo 
#          sleep 6
          #reboot -f
          
       elif [ $1 -eq 2 ]
       then
          echo upgrade fail file not valid
          echo "d 14" > /tmp/mqttdownfifo 
       fi
   fi
}


need=0
iot_upgrade=$1

if [ $# -gt 1 ] ; then
  dir=$2                          
else                                         
  dir=/media/mmcblk0p1                       
fi                                           

file=root_uImage
bfile=bImage
kernel_block=851968
burn_cmd=/bin/mtd_write
target_md5=`cat $dir/_md5_`
target_b_md5=`cat $dir/_bmd5_`
echo 3 > /proc/sys/vm/drop_caches


clear_history()
{
   rm -f $dir/bak-root_uImag	
   rm -f $dir/install.sh.bak
   rm -f $dir/prt_com.log*
   rm -f $dir/iot-linkit.log*
   rm -f $dir/httpclient.log*  
   rm -f update.log
}
post_pro_file()
{
      if [ -f $dir/creality/batch-update ] 
      then
        echo do not rm
      elif [ -f $dir/creality/debug ] 
      then
        mv -f $dir/$file $dir/bak-root_uImag
      else
        rm -f $dir/$file 
        rm -f $dir/$bfile
        rm -f $dir/_*md5_ 
        rm -f $dir/install.sh 
      fi
}


chkbupdate()
{
  target_tick=`date -d "2020-8-14 14:0:0" +%s`
  y=`uname -a | awk '{print $10}'`
  mon=`uname -a | awk '{print $6}'`
  d=`uname -a | awk '{print $7}'`

  case $mon in
  Jan )
     mon=1
     ;;

  Feb )
     mon=2
     ;;

  Mar )
     mon=3
     ;;

  Apr )
     mon=4
     ;;

  May )
     mon=5
     ;;

  Jun )
    mon=6
   ;;
   
  Jul )
     mon=7
     ;;

  Aug )
     mon=8
     ;;

  Sep )
     mon=9
     ;;

  Oct )
     mon=10
     ;;

  Nov )
     mon=11
     ;;

  Dec )
     mon=12
     ;;

   esac

  date="$y-$mon-$d `uname -a | awk '{print $8}'`"
  release_tick=`date -d "$date" +%s`
  if [ $target_tick -gt $release_tick ]
  then 
    target_b_md5=`cat $dir/_bmd5_`
    real_b_md5=`md5sum $dir/$bfile | awk '{print $1}'`
    if [ $target_b_md5 == $real_b_md5 ] 
    then
      return 1
    fi 
  fi
  return 2
}

update_boot()
{
  chkbupdate 
  if [ $? == 1 ]
  then
    boot_block=196608
    echo $burn_cmd -o 0 -l $boot_block write $dir/$bfile Bootloader
    $burn_cmd -o 0 -l $boot_block write $dir/$bfile Bootloader
  fi
}

#if diff $dir/ver /home/box_version
#then
#  echo no need to upgrade
#  exit 0
#fi




if [ -f $dir/$file ] ;then 
  need=1
fi

if [ $need -eq 1 ] ; then
  size=`ls -l $dir/root_uImage | awk '{print $5 }'`
  echo FW size $size
  fs_size=`expr $size - $kernel_block`
  echo fs size $fs_size

  if [ $size -gt $kernel_block -a $fs_size -gt 0 ] ; then
    real_md5=`md5sum $dir/$file | awk '{print $1}'`
    echo md5 of upgrade file: $real_md5 
    echo target md5 for upgrade: $target_md5 

    if [ $target_md5 == $real_md5 ] ; then
      #gpio l 40 4000 0 1 0 4000
      echo 3 > /proc/sys/vm/drop_caches
      clear_history
      update_boot
      $burn_cmd -o 0 -l $kernel_block write $dir/$file Kernel  
      echo 3 > /proc/sys/vm/drop_caches

      $burn_cmd -o $kernel_block -l $fs_size write $dir/$file RootFS  

      nvram_set 2860 old_firmware "`cat /proc/version `"
      post_pro_file

      echo 3 > /proc/sys/vm/drop_caches
      # it can't use the mv for tf card :buggy 
      sync
      echo done  
      upgrade_result 1
      #gpio l 40 0 4000 1 0 4000
      if [ x$iot_upgrade = x"byiot" ]
      then
        sleep 6
      else
         sleep 3
       fi
      reboot -f 
      exit 0
    fi

  fi

fi
upgrade_result 2
